#include  <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

double gtod_timer(void);

int main (int argc, char* argv[]){

  int  N, N2, i;


  double PI25DT = 3.141592653589793238462643e0;
  double deltax, halfdeltax, x, mult, area, pi, error, t0,t1,time;
  char line[12];

  gets(line);
  
  N = atoi(line);

   
  deltax = 2.0e0/N;
  halfdeltax = 0.5e0 * deltax;
  N2 = 2 * N;
  area = 0.0e0;
   
  t0 = gtod_timer();

  for (i = 1; i <= N2-1; i++){
    x = -1.0e0 + (double)i * halfdeltax;
    mult = ((double)(i%2)*2.0e0) + 2.0e0;
    area = area + mult * sqrt(1.0e0 - x*x) * halfdeltax;
  }
  t1 = gtod_timer();

  area = area/3.0e0;
  pi   = area*2.0e0;

  error = fabs(PI25DT - pi);
  time  = t1 - t0;
   
  printf("The value of pi and error: %17.14lf %17.14lf\n", pi, error);

  printf("The calculation time was : %lf %lf %lf\n",time,t0,t1); 
   
}

double gtod_secbase = 0.0E0;

double gtod_timer()
{
  struct timeval tv;
  void *Tzp=0;
  double sec;

  gettimeofday(&tv, Tzp);

  /*Always remove the LARGE sec value
    for improved accuracy  */
  if(gtod_secbase == 0.0E0)
    gtod_secbase = (double)tv.tv_sec;
  sec = (double)tv.tv_sec - gtod_secbase;

  return sec + 1.0E-06*(double)tv.tv_usec;
}
