program simpson

integer :: N, N2, i
integer :: t0, t1, freq

integer,   parameter :: KR8 = selected_real_kind(13)
real(KR8)            :: PI25DT = 3.141592653589793238462643_KR8
real(KR8) :: deltax, halfdeltax, x, mult, area, pi, time

   write (6,*) 'How many intervals?'
   read (5,*) N
   
   deltax = 2.0d0/N
   halfdeltax = 0.5d0 * deltax
   N2 = 2 * N
   area = 0.0d0
   
   call system_clock(count_rate=freq)
   call system_clock(count=t0)

   do i = 1, N2-1
      x = -1.0d0 + dble(i) * halfdeltax
      mult = (dble(mod(i,2))*2.0d0) + 2.0d0
      area = area + mult * sqrt(1.0d0 - x*x) * halfdeltax
   end do

   area = area / 3.0d0
   pi = area * 2.0d0

   call system_clock(count=t1)
   time = real(t1 - t0) / real(freq)
   error = abs(PI25DT - pi)
   
   write (6,*) 'The value of pi and error: ', pi, error
   write (6,*) 'The calculation time was ', time
   
end program
